Description

As promised in #22701, | now would like to propose a patch, which adds handling of issue relations to the CSV importer.
Usage

The attached patch extends the import configuration view with a new block, so that users may select a column for each relation type.
The parent issue field also moved to the new block, since it's conceptually related.

Within the CSV file the columns may define multiple relations of the same type, each separated with ,. Related issues follow the
same rules as parent issues. A string preceded with a # is supposed to be an existing issue. Without the # it's supposed to be
another row within the import file. For follows and precedes relations an additional delay may be present, e.g. #12 3d specifying a
relation to issue #12 and a delay of 3 days.

Technical notes

Since issue relations may only be created when the issue was already saved, I've added a second step to the import. Additionally to
build_object, which needs to be implemented by Import sub classes, there's also a extend_object method now. This is used by the
Issuelmporter to save the relations after the issue was already saved successfully.

Additional considerations

Initially, | wanted to build the import, so that issue relations exported from Redmine could be imported directly. But the format that's
used by the exporter was designed for humans, not so much for computers. Most importantly, to parse this format we would need to
grep for the localized relation names, which might even change between versions of Redmine. Therefore | settled for the proposed
approach of having separate columns for each relation type.

Related issues:

Related to Redmine - Feature #22701: Allow forward reference to parent when i... Closed
Related to Redmine - Feature #28213: Support external ID when importing issues Closed
Related to Redmine - Defect #35656: When importing issue relations, the valid... Closed
Has duplicate Redmine - Feature #33330: Import of issue relations when import... Closed

Associated revisions

Revision 19753 - 2020-05-06 02:37 - Go MAEDA

Support issue relations when importing issues (#28198).

Patch by Gregor Schmidt and Marius BALTEANU.

Revision 19754 - 2020-05-06 06:19 - Go MAEDA
Update locales (#28198).

History

#1 - 2018-02-19 14:37 - Gregor Schmidt

- File 0002-Support-issue-relations-when-importing-issues.patch added

This issue is in conflict with #28213. Since | would like to see both being applied, here's a patch for this issue applied on top of #28213

#2 - 2018-02-19 17:04 - Mischa The Evil
- Related to Feature #22701: Allow forward reference to parent when importing issues added

#3 - 2018-02-19 17:04 - Mischa The Evil
- Related to Feature #28213: Support external ID when importing issues added

#4 - 2018-02-19 17:06 - Mischa The Evil

- Target version set to Unplanned backlogs

#5 - 2019-05-06 16:13 - Go MAEDA

- Target version changed from Unplanned backlogs to Candidate for next major release

#6 - 2020-04-20 20:38 - Marius BALTEANU

- Has duplicate Feature #33330: Import of issue relations when imported from csv added

#7 - 2020-04-21 00:29 - Marius BALTEANU
- Assignee set to Marius BALTEANU

#8 - 2020-04-28 08:36 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0
Setting the target version to 4.2.0.

#9 - 2020-04-28 08:38 - Go MAEDA

- Target version changed from 4.2.0 to Candidate for next major release

Go MAEDA wrote:

Setting the target version to 4.2.0.

Sorry, | have changed the target version mistakenly.

#10 - 2020-05-03 15:59 - Marius BALTEANU

- File issue_relations.png added

- File 0002-Fix-failing-test.patch added

- File 0001-Rebased-patch-from-28198.patch added
- Assignee deleted (Marius BALTEANU)

- Target version changed from Candidate for next major release to 4.2.0

I've updated the patch posted by Greg to apply cleanly on the current trunk and to fix all Rubocop warnings.

Additionally, I'm adding a new patch (0002-Fix-failing-test.patch) that fixes a failing test (test_parent_and_follows_relation) by updating the test
assertions. From my checks, assertions were wrong in the initial patch because the start/due dates change after the follows relations are applied. I've
double check the test expectations by reproducing the test from Ul. A double check were is welcome.

Also, the initial patch:
® adds a new section in the Ul named "Issue relations" which is collapsed by default
¢ moves the fields Unique ID and Parent task under this section along with the relation type fields. I'm not sure if it's the best idea to move those

two fields as well.

issue_relations.png
All tests pass: https://gitlab.com/redmine-org/redmine/pipelines/142141722

I'll add the patch for auto-mapping fields after we integrate this one.

#11 - 2020-05-06 02:38 - Go MAEDA
- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

2025-07-06 2/3


https://gitlab.com/redmine-org/redmine/pipelines/142141722

Committed the patch. Thank you for this good improvement.

#12 - 2020-05-06 03:33 - Go MAEDA

- Category changed from Issues to Importers

#13 - 2020-05-06 15:17 - Marius BALTEANU

Is it ok to leave the Unique ID and Parents task fields under the "Issue relations" section?
#14 - 2020-05-06 15:58 - Go MAEDA
Marius BALTEANU wrote:
Is it ok to leave the Unique ID and Parents task fields under the "Issue relations" section?
| noticed that but | thought that those fields can be said as "relations". Personally, | don't mind those fields being categorized as "Issue relations”, but it
could possibly confuse existing users.
Which do you think better? | am OK with either.
#15 - 2020-05-06 17:49 - Marius BALTEANU
Go MAEDA wrote:

I noticed that but | thought that those fields can be said as "relations". Personally, | don't mind those fields being categorized as "Issue relations",
but it could possibly confuse existing users.

Which do you think better? | am OK with either.
I'm in the same case as you, not knowing which option is better. Maybe we receive a 3rd opinion on this.
#16 - 2021-07-13 05:50 - Simon Parker

Would you be able to update the "HowTo import issues" wiki with information on how this works, please? I'm having trouble getting it to work.
HowTo_import_issues

#17 - 2022-02-20 17:17 - Marius BALTEANU

- Related to Defect #35656: When importing issue relations, the validation messages are not shown in the Ul added

Files

0001-Support-issue-relations-when-importing-issues.patch 16.2 KB 2018-02-16 Gregor Schmidt
0002-Support-issue-relations-when-importing-issues.patch 19.8 KB 2018-02-19 Gregor Schmidt
issue_relations.png 80 KB 2020-05-03 Marius BALTEANU
0002-Fix-failing-test.patch 3.32 KB 2020-05-03 Marius BALTEANU
0001-Rebased-patch-from-28198.patch 19.8 KB 2020-05-03 Marius BALTEANU
